/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gsi;

    import java.util.*;

/**
 *
 * @author demel
 */
public class Node {
    Gsi model;
    String  name;
    String  txtType;
    enum TypIn {OR,EOR,AND};
    enum TypOut{D,ST};
    TypIn typIn;
    TypOut typOut;
    List<Arc> fwdLinks = new ArrayList<Arc>(20);
    List<Arc> bwdLinks = new ArrayList<Arc>(20);
    Double lastFired = -1.0;
    enum EorState {IDLE,POSTPONED,FAILED};
    EorState eorState;
    Arc eorArc;
    Stat stat = new Stat();

    public Node(String pName, String TxtType) {
        name = pName;
        this.txtType = TxtType;
        setType();
    }
    
    public Node(java.util.Scanner f, Gsi model) {
        this.model = model;
        name = f.next();
        txtType = f.next().toLowerCase();
        printNode();
        setType();
    }

    private void setType() {
        if        (txtType.equalsIgnoreCase("stor")) {
            typIn = TypIn.OR;  typOut = TypOut.ST;
        } else if (txtType.equalsIgnoreCase("steor")) {
            typIn = TypIn.EOR;  typOut = TypOut.ST;
        } else if (txtType.equalsIgnoreCase("stand")) {
            typIn = TypIn.AND; typOut = TypOut.ST;
        } else if (txtType.equalsIgnoreCase("dor")) {
            typIn = TypIn.OR;  typOut = TypOut.D;
        } else if (txtType.equalsIgnoreCase("deor")) {
            typIn = TypIn.EOR;  typOut = TypOut.D;
        } else if (txtType.equalsIgnoreCase("dand")) {
            typIn = TypIn.AND; typOut = TypOut.D;
        } else {
            model.die("Unknown type of node: "+txtType);
        }
    }
    
    public void reset() {
        lastFired = -1.0;
        eorState = EorState.IDLE;
        eorArc = null;
    }
    
    public String toString() {
        return "Node:  " + name + "  " + txtType + "\n";
    }

    public void printNode() {
        System.out.print(toString());
    }

    public void fire() {
        if (model.time > lastFired) {
            model.log(2, model.time+":  node  "+name+"  fired");
            stat.regValue(model.time);
            lastFired = model.time;
            if (typOut == TypOut.D) {
                // start all outgoing arcs
                for (Arc arc: fwdLinks) {
                    arc.start();
                }
            } else {
                // start one randomly selected arc
                Double p = model.rng.nextDouble();
                for (Arc arc: fwdLinks) {
                    p -= arc.probab;
                    if (p <= 0.0) {
                        arc.start();
                        break;
                    }
                }
                // safeguard if sum of probab < 1.0
                if (p > 0.0) {
                    fwdLinks.get(0).start();
                }
            }
        } // end of normal fire
        else {
            model.log(2, model.time+":  supressed duplicate fire of node "+
                    name+" at the same model time");

        }
    }

    public void notified(Arc fromArc) {
        // fromArc stopped. Try to fire ouserlves.

        model.log(4, "...trying to fire node "+name);
        if (typIn == TypIn.OR) {
            // clear signal and fire
            fromArc.signalling = false;
            fire();
        } else if (typIn == TypIn.AND) {
            // if all bwd arcs signalled  cler all signals and fire
            boolean canBeFired=true;
            for (Arc a: bwdLinks) {
                if (!a.signalling) {
                    canBeFired = false;
                    break;
                }
            }
            if (canBeFired) {
                for (Arc a: bwdLinks) {
                    a.signalling = false;
                }
                fire();
            }
        }
        else if (typIn == TypIn.EOR) {
            if (eorState == EorState.IDLE) {
                eorState = EorState.POSTPONED;
                eorArc = fromArc;
                model.registerPostponedEorNode(this);
                model.log(4, "... "+name+" postponed");
            } else {
                eorState = EorState.FAILED;
                model.log(4, "... "+name+" failed");
            }
    
        }
    }
    
    public void release() {
        if (eorState == EorState.POSTPONED) {
            model.log(4, "... "+name+" released");
            eorArc.signalling = false;
            eorState = EorState.IDLE;
            fire();
        } else if (eorState == EorState.FAILED) {
            model.log (2, model.time + ":  EOR node " + name + " failed");
            for (Arc a: bwdLinks) {
                if (a.signalling) {
                    a.signalling = false;
                    model.logc (3, "    concurent " + a.toString());
                }
            }
            eorState = EorState.IDLE;
        } 
        else {
            model.die ("Error:  Idle EOR node "+name+" in model.blockedEorNodes");
        }
    }

}
